// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2018 Thomas Klose & Torsten Schache, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;
using System.IO;
using Cairo;
using Gdk;
using Gtk;


namespace Hiperscan.Extensions.ApoIdent
{
    
    public class CellRendererSubstanceCategory : Gtk.CellRendererToggle
    {
        public const string GLIB_PROPERTY    = "substance_category";
        
        private static ImageSurface GreenPoint    {get; set;}
        private static ImageSurface YellowPoint    {get; set;}
        private static ImageSurface RedPoint    {get; set;}
        private static ImageSurface BlackPoint  {get; set;}

        
        public static void Init()
        {
            int size = 18;

            string tmp_file = System.IO.Path.GetTempFileName();
            Pixbuf tmp_pixbuf;

            tmp_pixbuf = new Pixbuf(null, "green_point.png", size, size);
            tmp_pixbuf.Save(tmp_file, "png");
            CellRendererSubstanceCategory.GreenPoint = new ImageSurface(tmp_file);
            
            tmp_pixbuf = new Pixbuf(null, "yellow_point.png", size, size);
            tmp_pixbuf.Save(tmp_file, "png");
            CellRendererSubstanceCategory.YellowPoint = new ImageSurface(tmp_file);

            tmp_pixbuf = new Pixbuf(null, "red_point.png", size, size);
            tmp_pixbuf.Save(tmp_file, "png");
            CellRendererSubstanceCategory.RedPoint = new ImageSurface(tmp_file);


            tmp_pixbuf = new Pixbuf(null, "black_point.png", size, size);
            tmp_pixbuf.Save(tmp_file, "png");
            CellRendererSubstanceCategory.BlackPoint = new ImageSurface(tmp_file);
            try
            {
                File.Delete(tmp_file);
            }
            catch (Exception)
            {
            }
        }
        
        
        
        protected override void Render (Gdk.Drawable window, Widget widget, Gdk.Rectangle background_area, Gdk.Rectangle cell_area, Gdk.Rectangle expose_area, CellRendererState flags)
        {
             Cairo.Context context = Gdk.CairoHelper.Create(window);
            
            switch(this.Category)
            {
            case SubstanceCategory.SingleSubstance:
                context.SetSource(CellRendererSubstanceCategory.GreenPoint, cell_area.X + 12, cell_area.Y + 3);
                
                break;
                
            case SubstanceCategory.Classifiaction:
                context.SetSource(CellRendererSubstanceCategory.YellowPoint, cell_area.X + 12, cell_area.Y + 3);
                break;
                
            case SubstanceCategory.NotMeasurable:
                context.SetSource(CellRendererSubstanceCategory.RedPoint, cell_area.X + 12, cell_area.Y + 3);
                break;

                case SubstanceCategory.UserDefined:
                    context.SetSource(CellRendererSubstanceCategory.BlackPoint, cell_area.X + 12, cell_area.Y + 3);
                    break;
                
            default:
                break;
            }
            
            context.Paint();
            
             (context.GetTarget() as System.IDisposable).Dispose();
             (context as IDisposable).Dispose();
            
            //base.Render(window, widget, background_area, cell_area, expose_area,flags);
         }

        
        [GLib.Property(CellRendererSubstanceCategory.GLIB_PROPERTY)]
        public SubstanceCategory Category {get; set;}
    }
}

